Ruby trunk - Feature #4780

String#split with a block
05/25/2011 11:41 PM - yimutang (Joey Zhou)

Status: Closed

Priority: Normal

Assignee: matz (Yukihiro Matsumoto)
Target version:

Description
Mentioned before, in another (rejected) issue thread: http:/redmine.ruby-lang.org/issues/4615

There are a few methods, which return an array without a trailing block, or also can be iterated with a block.

Such as String#scan.

String#split has only one form:

str.split (pattern=$;, 1limit=0) -> array

Maybe add a iterative form, when with a block:

str.split (pattern=$;, limit=0) {|field| ... } —-> str

If the string is very long, and | only need to play with the splitted string one by one, this will not create a useless expensive array.

Joey

Related issues:
Related to Ruby trunk - Feature #4615: Add IO#split and iterative form of Str... Rejected 04/26/2011

Associated revisions

Revision 2258a97f - 03/15/2018 11:08 AM - nobu (Nobuyoshi Nakada)
string.c: split with block

e string.c (rb_str_split_m): yield each split substrings if the block is given, instead of returing the array. [Feature #4780]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62763 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 62763 - 03/15/2018 11:08 AM - nobu (Nobuyoshi Nakada)
string.c: split with block
e string.c (rb_str_split_m): yield each split substrings if the block is given, instead of returing the array. [Feature #4780]
Revision 62763 - 03/15/2018 11:08 AM - nobu (Nobuyoshi Nakada)
string.c: split with block
e string.c (rb_str_split_m): yield each split substrings if the block is given, instead of returing the array. [Feature #4780]
Revision 1bf9dec0 - 03/17/2018 04:13 AM - nobu (Nobuyoshi Nakada)
string.c: [DOC] split with block [ci skip]
e string.c (rb_str_split_m): [DOC] about split with block. [Feature #4780]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62790 b2dd03c8-39d4-4d8f-98ff-823fe690080e
Revision 62790 - 03/17/2018 04:13 AM - nobu (Nobuyoshi Nakada)
string.c: [DOC] split with block [ci skip]

e string.c (rb_str_split_m): [DOC] about split with block. [Feature #4780]

Revision 62790 - 03/17/2018 04:13 AM - nobu (Nobuyoshi Nakada)
string.c: [DOC] split with block [ci skip]

e string.c (rb_str_split_m): [DOC] about split with block. [Feature #4780]

History

#1 - 05/27/2011 10:28 PM - naruse (Yui NARUSE)
- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

#2 - 11/09/2012 06:03 PM - mame (Yusuke Endoh)

- Target version set to 2.6

#3 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)
- Target version deleted (2.6)

#4 - 03/15/2018 08:55 AM - matz (Yukihiro Matsumoto)
Accepted.

Matz.

#5 - 03/15/2018 09:00 AM - nobu (Nobuyoshi Nakada)

- Description updated

#6 - 03/15/2018 11:08 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

Applied in changeset trunk|r62763.

string.c: split with block

e string.c (rb_str_split_m): yield each split substrings if the block is given, instead of returing the array. [Feature #4780]

01/23/2019

22


https://bugs.ruby-lang.org/projects/ruby-trunk/repository/trunk/revisions/62763
https://bugs.ruby-lang.org/issues/4780
http://www.tcpdf.org

